// 
// CApplication
// 
// This is the main part of the program. This is were it all comes together.
//

#ifndef APPLICATION_H
#define APPLICATION_H

#include <vector>
#include <string>

#include "mainwnd.h"

#define MSG_SHOWIMAGE (WM_USER + 1) 

class asIScriptEngine;
class asIScriptContext;
class CImageWnd;
class CFloatImage;

class CApplication
{
public:
	CApplication();

	int Run();

	void SetScript(const char *scriptFile);
	int CompileScript();
	int ExecuteScript();
	void AbortWork();

	bool IsWorking() {return isWorking;}
	bool IsExecuting() {return isWorking ? isExecuting : 0;}

	void ShowImage(CFloatImage *image);
	void OpenImageWindow(int imageWindow);

	void ExceptionCallback(asIScriptContext *ctx);
	void LineCallback(asIScriptContext *ctx);

	CMainWnd wnd;
	asIScriptEngine *scriptEngine;

	asIScriptContext *context;

protected:
	void FreeMemory();

	friend void CompileThread(void *data);
	friend void ExecuteThread(void *data);
	
	bool isWorking;
	bool isExecuting;
	bool doAbortWork;

	std::string scriptFile;
	bool scriptOK;

	std::vector<CImageWnd *> imageWindows;
};

extern CApplication app;

#endif