//
// CImage
//
// This class is a simple structure for holding image data. It has methods for
// using this image date together with GDI. It is easier to manipulate than a 
// HBITMAP, or GDI DIB structure.
//

#ifndef AC_IMAGE_H
#define AC_IMAGE_H

#define EIMG_FAILED_TO_OPEN_FILE -1
#define EIMG_OUT_OF_MEMORY       -2
#define EIMG_UNSUPPORTED_FORMAT  -3

#define WIN32_LEAN_AND_MEAN
#include <windows.h>	// HDC

typedef unsigned long PIXEL;

class CImage
{
public:
	CImage();
	CImage(int width, int height);
	virtual ~CImage();

	int CopyToDC(HDC dc, int x, int y, int w, int h);
	int Create(int w, int h);
	void GetBitmapInfoHeader(BITMAPINFOHEADER *bmih);

	PIXEL *pixels;
	int    width;
	int    height;
	bool   isTopDown;
};


#endif