// 
// CImageWnd
//
// This window displays an image generated by the script, and allows the 
// user to examine the image in detail before saving it if he/she chooses to.
//

#ifndef IMAGEWND_H
#define IMAGEWND_H

#include "ac_window.h"
#include "image.h"

class CFloatImage;

class CImageWnd : public acCWindow
{
public:
	CImageWnd();

	int Create(acCWindow *parent);
	void CopyImage(CFloatImage *img);

protected:
	LRESULT MsgProc(UINT msg, WPARAM wParam, LPARAM lParam);

	void OnPaint();
	void OnSaveAs();
	void OnSize();
	void OnScroll(UINT scrollBar, UINT action);
	void OnScale(float newScale);
	void OnInitMenuPopup(HMENU hMenu, int pos, BOOL isWindowMenu);

	void UpdateScrollBars();
	void ProcessImage();

	int GetHorzScroll();
	int GetVertScroll();

	void Draw();
	void DrawImage(int x, int y);

	CImage buffer;
	CImage originalImage;
	CImage image;
	float scale;
	bool viewAlpha;
	bool viewTiled;
};

#endif